module R6502
  class Cpu
    def instr_mode(opcode)
    #adc
      { 0x69 => [:adc, :imm],
        0x65 => [:adc, :zp],
        0x75 => [:adc, :zpx],
        0x6d => [:adc, :abs],
        0x7d => [:adc, :absx],
        0x79 => [:adc, :absy],
        0x61 => [:adc, :indx],
        0x71 => [:adc, :indy],
    #and
        0x29 => [:and, :imm],
        0x25 => [:and, :zp],
        0x35 => [:and, :zpx],
        0x2d => [:and, :abs],
        0x3d => [:and, :absx],
        0x39 => [:and, :absy],
        0x21 => [:and, :indx],
        0x31 => [:and, :indy],
    #asl
        0x0a => [:asl, :acc],
        0x06 => [:asl, :zp],
        0x16 => [:asl, :zpx],
        0x0e => [:asl, :abs],
        0x1e => [:asl, :absx],
    #bit
        0x24 => [:bit, :zp],
        0x2c => [:bit, :abs],
    #bpl
        0x10 => [:bpl, :rel],
    #bmi
        0x30 => [:bmi, :rel],
    #bvc
        0x50 => [:bvc, :rel],
    #bvs
        0x70 => [:bvs, :rel],
    #bcc
        0x90 => [:bcc, :rel],
    #bcs
        0xb0 => [:bcs, :rel],
    #bne
        0xd0 => [:bne, :rel],
    #beq
        0xf0 => [:beq, :rel],
    #brk
        0x00 => [:brk, :imp],
    #cmp
        0xc9 => [:cmp, :imm],
        0xc5 => [:cmp, :zp],
        0xd5 => [:cmp, :zpx],
        0xcd => [:cmp, :abs],
        0xdd => [:cmp, :absx],
        0xd9 => [:cmp, :absy],
        0xc1 => [:cmp, :indx],
        0xd1 => [:cmp, :indy],
    #cpx
        0xe0 => [:cpx, :imm],
        0xe4 => [:cpx, :zp],
        0xec => [:cpx, :abs],
    #cpy
        0xc0 => [:cpy, :imm],
        0xc4 => [:cpy, :zp],
        0xcc => [:cpy, :abs],
    #dec
        0xc6 => [:dec, :zp],
        0xd6 => [:dec, :zpx],
        0xce => [:dec, :abs],
        0xde => [:dec, :absx],
    #eor
        0x49 => [:eor, :imm],
        0x45 => [:eor, :zp],
        0x55 => [:eor, :zpx],
        0x4d => [:eor, :abs],
        0x5d => [:eor, :absx],
        0x59 => [:eor, :absy],
        0x41 => [:eor, :indx],
        0x51 => [:eor, :indy],
    #clc
        0x18 => [:clc, :imp],
    #sec
        0x38 => [:sec, :imp],
    #cli
        0x58 => [:cli, :imp],
    #sei
        0x78 => [:sei, :imp],
    #clv
        0xb8 => [:clv, :imp],
    #cld
        0xd8 => [:cld, :imp],
    #sed
        0xf8 => [:sed, :imp],
    #inc
        0xe6 => [:inc, :zp],
        0xf6 => [:inc, :zpx],
        0xee => [:inc, :abs],
        0xfe => [:inc, :absx],
    #jmp,
        0x4c => [:jmp, :abs],
        0x6c => [:jmp, :ind],
    #jsr,
        0x20 => [:jsr, :abs],
    #lda,
        0xa9 => [:lda, :imm],
        0xa5 => [:lda, :zp],
        0xb5 => [:lda, :zpx],
        0xad => [:lda, :abs],
        0xbd => [:lda, :absx],
        0xb9 => [:lda, :absy],
        0xa1 => [:lda, :indx],
        0xb1 => [:lda, :indy],
    #ldx,
        0xa2 => [:ldx, :imm],
        0xa6 => [:ldx, :zp],
        0xb6 => [:ldx, :zpy],
        0xae => [:ldx, :abs],
        0xbe => [:ldx, :absy],
    #ldy,
        0xa0 => [:ldy, :imm],
        0xa4 => [:ldy, :zp],
        0xb4 => [:ldy, :zpx],
        0xac => [:ldy, :abs],
        0xbc => [:ldy, :absx],
    #lsr,
        0x4a => [:lsr, :acc],
        0x46 => [:lsr, :zp],
        0x56 => [:lsr, :zpx],
        0x4e => [:lsr, :abs],
        0x5e => [:lsr, :absx],
    #nop,
        0xea => [:nop, :imp],
    #ora,
        0x09 => [:ora, :imm],
        0x05 => [:ora, :zp],
        0x15 => [:ora, :zpx],
        0x0d => [:ora, :abs],
        0x1d => [:ora, :absx],
        0x19 => [:ora, :absy],
        0x01 => [:ora, :indx],
        0x11 => [:ora, :indy],
    #tax,
        0xaa => [:tax, :imp],
    #txa,
        0x8a => [:txa, :imp],
    #dex,
        0xca => [:dex, :imp],
    #inx,
        0xe8 => [:inx, :imp],
    #tay,
        0xa8 => [:tay, :imp],
    #tya,
        0x98 => [:tya, :imp],
    #dey,
        0x88 => [:dey, :imp],
    #iny,
        0xc8 => [:iny, :imp],
    #rol,
        0x2a => [:rol, :acc],
        0x26 => [:rol, :zp],
        0x36 => [:rol, :zpx],
        0x2e => [:rol, :abs],
        0x3e => [:rol, :absx],
    #ror,
        0x6a => [:ror, :acc],
        0x66 => [:ror, :zp],
        0x76 => [:ror, :zpx],
        0x6e => [:ror, :abs],
        0x7e => [:ror, :absx],
    #rti,
        0x40 => [:rti, :imp],
    #rts,
        0x60 => [:rts, :imp],
    #sbc,
        0xe9 => [:sbc, :imm],
        0xe5 => [:sbc, :zp],
        0xf5 => [:sbc, :zpx],
        0xed => [:sbc, :abs],
        0xfd => [:sbc, :absx],
        0xf9 => [:sbc, :absy],
        0xe1 => [:sbc, :indx],
        0xf1 => [:sbc, :indy],
    #sta,
        0x85 => [:sta, :zp],
        0x95 => [:sta, :zpx],
        0x8d => [:sta, :abs],
        0x9d => [:sta, :absx],
        0x99 => [:sta, :absy],
        0x81 => [:sta, :indx],
        0x91 => [:sta, :indy],
    #txs,
        0x9a => [:txs, :imp],
    #tsx,
        0xba => [:tsx, :imp],
    #pha,
        0x48 => [:pha, :imp],
    #pla,
        0x68 => [:pla, :imp],
    #php,
        0x08 => [:php, :imp],
    #plp,
        0x28 => [:plp, :imp],
    #stx,
        0x86 => [:stx, :zp],
        0x96 => [:stx, :zpy],
        0x8e => [:stx, :abs],
    #sty,
        0x84 => [:sty, :zp],
        0x94 => [:sty, :zpx],
        0x8c => [:sty, :abs] }[opcode]
    end
  end
end
